!********************************************************************
!     
      subroutine recupsed
!     
!********************************************************************
!     
!     objet    :  gestion de la reprise de calcul a partir d un etat
!                 enregistre dans un fichier (netcdf ou binaire acces direct)
!                 lors d un run anterieur
!               
!
!
!     appelant         : stepu
!                      :
!     appeles          : ionc_ouvrel, ionc_lit_t, ionc_litr8
!     appeles          : ionc_litr4_xyt, ionc_litr4_zxyt
!                      :
!     canal d ecriture :
!                      :
!     canal de lecture : 26, filrepsed
!                      :
!     cle cpp          : key_netcdf, key_notra
!                      :
!     variables in     : repxuvwbz, repsal, reptemp, repturb, reptra, ntra
!     variables in     : pasauv
!                      :
!     variables out    : u, uz, xu, v, vz, xv, sal, temp, tz
!     variables out    : ect, bz, nz, kz, vis2d, wz, vish_xe, vish_phi
!     variables out    : tsauv, t, dt
!                      :
!     variables inout  : 
!                      :
!     dernieres modifs : 11/09/02
!                      :
!***********************************************************
!   
#ifdef key_sedim_anc
use comsedim
use comsubstance, only : nv_adv,flx_s2w,flx_w2s
implicit none
!#     include "incbio.h"

!
      character nomc*8
      integer i,j,k,iv
      real(kind=riosh),dimension(ksdmax,imin:imax,jmin:jmax)   ::  tzecrits
      real(kind=riosh),dimension(imin:imax,jmin:jmax)          :: xind
!
!************************************************************
!     Executable statements
!************************************************************
!
      call ionc_ouvrel(filrepsed)
!
      call ionc_litr4_xyt(filrepsed,'ksmi',xind,imin,imax,jmin,jmax,1)
      do j=jmin,jmax
       do i=imin,imax
        ksmi(i,j)=int(xind(i,j))
       end do
      end do
!
      call ionc_litr4_xyt(filrepsed,'ksma',xind,imin,imax,jmin,jmax,1)
      do j=jmin,jmax 
       do i=imin,imax 
        ksma(i,j)=int(xind(i,j)) 
       end do 
      end do
!
      call                                                              &
     & ionc_litr4_zxyt(filrepsed,'dzs',dzs,imin,imax,jmin,jmax,ksdmax,1)
!
      do iv = -1,nv_adv
      write(nomc,10) iv
      call                                                              &
     & ionc_litr4_zxyt(filrepsed,nomc,tzecrits,                         &
     &    imin,imax,jmin,jmax,ksdmax,1)
       do j = jmin,jmax
        do i = imin,imax
         do k = 1,ksdmax
          cv_sed(iv,k,i,j) = tzecrits(k,i,j)
         enddo
        enddo
       enddo
!
      write(nomc,20) iv
      call                                                              &
     & ionc_litr4_xyt(filrepsed,nomc,xind,imin,imax,jmin,jmax,1)
       do j = jmin,jmax
        do i = imin,imax
          flx_w2s(iv,i,j) = xind(i,j)
        enddo
       enddo
!
      enddo
!
      call ionc_fermer(filrepsed)
!
      tsauv=t+pasauv
!
   10 format('concen',i2.2)
   20 format('flx_w2s',i2.2)
!

#endif
      end
