!********************************************************************
!     
      subroutine sortiesed(tect)
!     
!********************************************************************
!     
!     appelant         : gessor, main
!                      :
!     appeles          : ionc_init, ionc_creer, ionc_torigine
!     appeles          : ionc_creer4_xyt, ionc_creer4_xy
!     appeles          : ionc_ecritr4_xy, ionc_ecritr4_xyt, ionc_ecrit_t
!     appeles          : ionc_creer4_zxyt, ionc_vatt_missing
!     appeles          : ionc_ecritr4_zxyt
!                      :
!     canal d ecriture : nomresu
!                      :
!     canal de lecture :
!                      :
!     cle cpp          : key_sedim_anc
!                      :
!     variables in     : tect, u, uz, x, v, vz, sal, temp, tz
!     variables in     : nomresu, valmanq_io, dgac, gwac, dfiac, fisac
!     variables in     : h0, wz, kz, nz, sig, sorcurbcl
!     variables in     : sorsal, sortemp, sornivi, sorcurbtp
!                      :
!     variables out    :
!                      :
!     variables inout  :
!                      :
!     dernieres modifs : 22/10/02
!                      :
!***********************************************************
!     
#ifdef key_sedim_anc

use comsedim
use comsubstance, only : nv_adv,name_var,irk_fil
implicit none
!
      integer                :: i,j,k,l,ifois
      character(len=4)       :: nomc
      character(len=12)      :: chaine
      real(kind=riosh),dimension(imin:imax,jmin:jmax) :: nniv,eptot
      real(kind=riosh),dimension(2,imin:imax,jmin:jmax) ::tzecrit
      real(kind=riosh),dimension(imin:imax,jmin:jmax) :: tecrit
      real(kind=rsh),dimension(ksdmin-1:ksdmax+1)     :: sig2
      real(kind=rsh),dimension(1:2)                   :: niv
      real(kind=rlg) tect
      data ifois /-1/
!
!************************************************************
!     Executable statements
!************************************************************
!
      ifois=ifois+1

      if(ifois.eq.0)then
!
!         sig2(0)=-0.001
!        do k=ksdmin,ksdmax
!         sig2(k)=(k-1)/(ksdmax-ksdmin)
!        end do
!         sig2(ksdmax+1)=1.0
!
!
         niv(1)=1
         niv(2)=2
! on ne veut que la couche de fond et de surface
! donc pas=1, et kmax=2
!

         call ionc_creer(nomsed,dgac,gwac,dfiac,fisac,imin,          &
     &                   imax,1,jmin,jmax,1,1,2,1,2,0,niv)

         call ionc_torigine(nomsed,dateref) 
         call ionc_tunite(nomsed,'seconds')
!

         call ionc_creer4_xy(nomsed,'H0','m',                           &
     &	 'bathymetrie par rapport au niv moyen',0,0)
         call ionc_ecritr4_xy(nomsed,'H0',h0,imin,imax,jmin,jmax)
!

         call ionc_creer4_xyt(nomsed,'EPTOT','m',                       &
     &   'epaisseur totale du sediment',0,0)
         call ionc_vatt_missing(nomsed,'EPTOT',-valmanq_io)
!
         call ionc_creer4_xyt(nomsed,'Nbniv','quantité',                &
     &   'Nombre de niveaux',0,0)
         call ionc_vatt_missing(nomsed,'Nbniv',-valmanq_io)
!
       call                                                             &
     & ionc_creer4_zxyt(nomsed,'DZS','m','epais de la couche',0,0)
       call ionc_vatt_missing(nomsed,'DZS',valmanq_io)
!
       do l = -1,nv_adv ! pour sauver T et S
!cval       do l = 1,nv_adv
       if (l > 0) chaine=trim(name_var(irk_fil(l)))
       if (l==-1) chaine='salinite'
       if (l==0)  chaine='temperature'
!
       write(nomc,10) l
       if (l==-1) nomc='SAL'
       if (l==0) nomc='TEM'
       
       call                                                             &
     & ionc_creer4_zxyt(nomsed,nomc,'u.s.i',chaine,0,0)
       call ionc_vatt_missing(nomsed,nomc,valmanq_io)
!
       enddo
!
       call ionc_creer4_xyt(nomsed,'TENFON','N.m-2',                    &
     &   'tension de frottement sur le fond pour l"erosion',0,0)
       call ionc_vatt_missing(nomsed,'TENFON',-valmanq_io)
!
      if(l_vague) then
       call ionc_creer4_xyt(nomsed,'TENFONC','N.m-2',                   &
     &   'tension de frottement due au courant',0,0)
       call ionc_vatt_missing(nomsed,'TENFONC',-valmanq_io)
!
       call ionc_creer4_xyt(nomsed,'TENFONW','N.m-2',                   &
     &   'tension de frottement due aux vagues',0,0)
       call ionc_vatt_missing(nomsed,'TENFONW',-valmanq_io)
!
!
       call ionc_creer4_xyt(nomsed,'fp','hz',                           &
     &   'peak frequency',0,0)
       call ionc_vatt_missing(nomsed,'fp',-valmanq_io)
!
!
       call ionc_creer4_xyt(nomsed,'hs','m',                            &
     &   'hauteur significative',0,0)
       call ionc_vatt_missing(nomsed,'hs',-valmanq_io)
       endif

!
     else
!     
       call ionc_ecrit_t(nomsed,0,tect)
!
       do j = jmin,jmax
        do i = imin,imax
          eptot(i,j)=0.0
         do k = ksdmin,ksdmax
           eptot(i,j)=eptot(i,j)+dzs(k,i,j)
         end do
        end do
       end do
      call ionc_ecritr4_xyt(nomsed,'EPTOT',eptot,imin,imax,jmin,jmax,0)
!
       do j = jmin,jmax
        do i = imin,imax
          nniv(i,j)=ksma(i,j)
        end do
       end do
      call ionc_ecritr4_xyt(nomsed,'Nbniv',nniv,imin,imax,jmin,jmax,0)
!
      do j = jmin,jmax
       do i = imin,imax
         if(ksma(i,j).gt.1) then
          tzecrit(2,i,j)=dzs(ksma(i,j),i,j)   
         else
          tzecrit(2,i,j)=valmanq_io
         endif      
	  tzecrit(1,i,j)=dzs(1,i,j)
       end do 
      end do 
      call                                                              &
     & ionc_ecritr4_zxyt(nomsed,'DZS',tzecrit,imin,imax,jmin,jmax,2,0)
!
      do l = -1,nv_adv
!cval      do l = 1,nv_adv
       do j = jmin,jmax
        do i = imin,imax
         if(ksma(i,j).gt.1) then
          tzecrit(2,i,j) = cv_sed(l,ksma(i,j),i,j)
         else
          tzecrit(2,i,j)=valmanq_io
         endif     
          tzecrit(1,i,j) = cv_sed(l,max(ksmi(i,j),1),i,j)
        enddo
       enddo
       write(nomc,10) l
       if (l==-1) nomc='TEM'
       if (l==0) nomc='SAL'

      call ionc_ecritr4_zxyt                                            &
     & (nomsed,nomc,tzecrit,imin,imax,jmin,jmax,2,0)

      enddo

      tecrit=tenfon
      call ionc_ecritr4_xyt(nomsed,'TENFON',tecrit                      &
     &      ,imin,imax,jmin,jmax,0)

      if (l_vague) then
      tecrit=tenfonc
      call ionc_ecritr4_xyt(nomsed,'TENFONC',tenfonc                    &
     &      ,imin,imax,jmin,jmax,0)
     tecrit=tenfonw
      call ionc_ecritr4_xyt(nomsed,'TENFONW',tenfonw                    &
     &      ,imin,imax,jmin,jmax,0)
     tecrit=fp
      call ionc_ecritr4_xyt(nomsed,'fp',fp                              &
     &      ,imin,imax,jmin,jmax,0)
     tecrit=hs
      call ionc_ecritr4_xyt(nomsed,'hs',hs                              &
     &      ,imin,imax,jmin,jmax,0)
!
       endif
!
!
      endif
!
   10 format('C',i2.2)
!
#else
!
#endif
!
       end
