! ***************************************************************************
      subroutine t_bilmat(cv_wat,xe)
!
!     calcul du bilan de masse
   !&E              2007-09 (V. Garnier) homogeneneity of dx dy...
! ***************************************************************************
!pas pret pour insant pnb compil #if defined key_sedim_anc || defined key_biolo || defined key_bioch
!ATT: MPI not yet tested!!!
#if defined key_sedim_anc
#ifdef key_agrif_use
use parametres
#else
use parametres,   only : rsh,rlg,imin,imax,jmin,jmax,kmax,ljmin,ljmax
#endif
!use comsedim,     only : ksdmin,ksdmax,flx_rej_cum,flx_obc_cum,stok_wat
use comsedim
use comsubstance, only : nv_adv,nvpc,name_bilfil,ibilg,ibild,jbilb,jbilh
use comvars2d,    only : t,dt
#ifdef key_MPI
use mpi, only:master, MPI_t_bilmat
#endif
implicit none

!
      integer                                    :: iv,i,j,k,ksmin,ksmax
      real(kind=rsh),dimension(imin:imax,ljmin:ljmax) :: xe
      real(kind=rsh),dimension (nb_var,kmax,imin:imax,ljmin:ljmax) :: cv_wat
      real(kind=rlg) :: dtm
      real(kind=rlg),dimension(ksdmin:ksdmax)    :: vol
#ifdef key_MPI
      real(kind=rlg),dimension(1:nv_adv)         :: flx_obc_cum_back, flx_rej_cum_back
#endif
      real(kind=rlg)                             :: voltot,bilo1
!
! definition de la zone ou est realisee le bilan
!
      if (ibilg==imin) ibilg=imin+2
      if (ibild==imax) ibild=imax-1
      if (jbilb==jmin) jbilb=jmin+2
      if (jbilh==jmax) jbilh=jmax-1
!
      dtm=0.5*dt
!
      stok_wat(1:nv_adv)=0.
      stok_sed(1:nv_adv)=0.
!
      bilo1=0.
      do j=jbilb,jbilh
#ifdef key_MPI
     if((j.ge.ljmin).and.(j.le.ljmax)) then
#endif
        do i=ibilg,ibild
          if(h0(i,j).ne.-valmanq) then

            do k=1,kmax
              voltot=dble(dzu(k)*(h0(i,j)+xe(i,j))*surf(i,j))
              bilo1=bilo1+voltot
              do iv=1,nv_adv
                stok_wat(iv)=stok_wat(iv)+dble(cv_wat(iv,k,i,j)*voltot)
                flx_rej_cum(iv)=flx_rej_cum(iv)+phicon(iv,k,i,j)
              enddo
            enddo     ! loop on k

            ksmin=ksmi(i,j)
            ksmax=ksma(i,j)
            do k=ksmin,ksmax

              vol(k)=dble(surf(i,j)*dzs(k,i,j))
              do iv=1,nvpc
                stok_sed(iv)=stok_sed(iv)+dble(cv_sed(iv,k,i,j)*vol(k))
              enddo
!cval            do iv=nvpc+1,nv-adv
!cval pour faire bilan des variables non constitutives * par la porosite ?
!cval            enddo
            enddo     ! loop on k

          endif
        enddo
#ifdef key_MPI
     endif
#endif
      enddo
!
      do i=ibilg,ibild
        do k=1,kmax
          do iv=1,nv_adv
          j=jbilb-1
#ifdef key_MPI
     if((j.ge.ljmin).and.(j.le.ljmax)) &
#endif
            flx_obc_cum(iv)=flx_obc_cum(iv)+fy(iv,k,i,j)*dzu(k)*dx_v(i,j)

          j=jbilh
#ifdef key_MPI
     if((j.ge.ljmin).and.(j.le.ljmax)) &
#endif
            flx_obc_cum(iv)=flx_obc_cum(iv)-fy(iv,k,i,j)*dzu(k)*dx_v(i,j)
          end do
        end do
      end do
!
      do j=jbilb,jbilh
#ifdef key_MPI
     if((j.ge.ljmin).and.(j.le.ljmax)) then
#endif
        do k=1,kmax
          do iv=1,nv_adv
            flx_obc_cum(iv)=flx_obc_cum(iv)+fx(iv,k,ibilg-1,j)*dzu(k)*dy(ibilg-1,j)
            flx_obc_cum(iv)=flx_obc_cum(iv)-fx(iv,k,ibild  ,j)*dzu(k)*dy(ibild  ,j)
          end do
        end do
#ifdef key_MPI
     endif
#endif
      end do
!
#ifdef key_MPI
!after test     if(MASTER) then
        flx_obc_cum_back(:)=flx_obc_cum(:)
        flx_rej_cum_back(:)=flx_rej_cum(:)
!after test     endif
      call(stok_wat(1:nv_adv),stok_sed(1:nv_adv),flx_obc_cum(1:nv_adv),flx_rej_cum(1:nv_adv),(nv_adv*4))
#endif

#ifdef key_MPI
     if(MASTER) then
#endif
      if (nbouc.eq.1) open(90,file=name_bilfil,status='replace',form='formatted', access='sequential')
!
      if (t.ge.tsorbil) then
      tsorbil=t+dt
      bil(1:nv_adv)=stok_wat(1:nv_adv)+stok_sed(1:nv_adv)-flx_obc_cum(1:nv_adv)-flx_rej_cum(1:nv_adv)
!
      write(90,100)t,                                                   &
        ((bil(iv),stok_wat(iv),stok_sed(iv),flx_obc_cum(iv),flx_rej_cum(iv)),       &
          iv=1,nv_adv)
      endif
!
#ifdef key_MPI
        flx_obc_cum(:)=flx_obc_cum_back(:)
        flx_rej_cum(:)=flx_rej_cum_back(:)
else
        if(flx_obc_cum(1).ne.flx_obc_cum_back) then
                write(*,*) 'something strange in t_bilmat with MPI'
                stop
        endif
#endif
  100 format(16(e20.14,1x))

#endif
      end
!
