subroutine tens_vague
!

#ifdef key_sedim_anc
use comsedim
use cometdyn
use comvars2d, only : nbouc,l_reprise
implicit none

include '/home/dedale/logiciels/NetCDF/include/netcdf.inc'


! 
!.. Local Scalars .. 
      integer       :: i,j,ii
      integer       :: code_erreur,id_tps,id_dimtps
      integer       :: jj_met,mm_met,aaaa_met,hh_met,min_met,sec_met
!
      real(kind=rsh)     :: u1,u2,a,b,c,d,l,lzero
      real(kind=rsh)     :: var1,var2,tera,epsi
      real(kind=rsh)     :: x,y,long,ubot,lon,tenfonmax
!
      real(kind=rlg)     :: datosec,dt1,dt2,Tp
      real(kind=rlg)     :: ptinf,ptsup,t_mod,t_int
! 
!.. Local Arrays .. 
!
      integer,dimension(imin:imax,jmin:jmax)  :: i1,i2,j1,j2
!
!  Dedie a lecture des donnees de fichier de vent
!-------------------------------------------------
      character(len=64),parameter             ::             &
        fic_vague_netcdf='/home4/creizic/fdufois/WW3/run01/wave01_mars.nc'
      integer,parameter :: njour_met=0 !Nombre de jours sur lesquels on boucle
      character(len=15),parameter :: Nom_Temps='time',       &
                                     Nom_Att_Temps='time_origin'
      integer,parameter   :: an_mod=1994,mois_mod=1,j_mod=1,h_mod=0, &
                             m_mod=0,s_mod=0
!
!
      character(len=19)  :: date_deb_met
      real(kind=rsh)     :: fw,excurs
      real(kind=rsh),parameter :: zzeroo=0.00001
      real(kind=rsh),dimension(imin:imax,jmin:jmax) :: dirv
!
! 
! 
! ... Executable Statements ...
!
!
      if( (nbouc .eq. 1 .and. l_reprise) .or. (nbouc .eq. 0) ) then
!
          t_model_00 = datosec('01/01/1900 00:00:00')
!
        call ionc_ouvrel(fic_vague_netcdf)
!
!
!
        write(*,*) 'Fichier vague :',fic_vague_netcdf
	code_erreur = NF_OPEN(fic_vague_netcdf,NF_NOWRITE,cdf0_id)
        if (code_erreur.ne.NF_NOERR) stop 'Erreur lors de NF_OPEN'
!         
        code_erreur = NF_INQ_VARID(cdf0_id,Nom_Temps,id_tps)
        if (code_erreur.ne.NF_NOERR) stop 'Erreur lors de NF_INQ_VARID'
!         
        code_erreur = NF_INQ_DIMID(cdf0_id,Nom_Temps,id_dimtps)
        if (code_erreur.ne.NF_NOERR) stop 'Erreur lors de NF_INQ_DIMID'
!         
        code_erreur = NF_INQ_DIMLEN(cdf0_id,id_dimtps,dim_tempsw)
        if (code_erreur.ne.NF_NOERR) stop 'Erreur lors de NF_INQ_DIMLEN'
!
        do ii = 1,dim_tempsw
         code_erreur = NF_GET_VAR1_DOUBLE(cdf0_id,id_tps,ii,t_met(ii))
         if (code_erreur.ne.NF_NOERR)                                   &
     &   STOP 'Erreur lors de NF_GET_VAR_REAL'
        enddo
!
!
!
!
        t_met(0) = t_met(dim_tempsw)+(t_met(2)-t_met(1))
!
        code_erreur= NF_GET_ATT_TEXT(cdf0_id,id_tps,Nom_Att_Temps       &
     & ,date_deb_met)
!
        date_deb_met="01-01-1900 00:00:00"
	call decompdate(date_deb_met,jj_met,mm_met,aaaa_met,                  &
     &  hh_met,min_met,sec_met)
!
     t_met_00 = datosec('01/01/1900 00:00:00')
!
        t_int = t+(t_model_00-t_met_00)
!
        if(njour_met.gt.0.) then
         t_mod = dmod(t,dfloat(njour_met)*86400.d0)+                    &
     &		(t_model_00-t_met_00)
         write(*,*) 'boucle sur le fichier vague pdt '                  &
     &   ,dint(t_int/(dfloat(njour_met)*86400.d0)), ' ans'
        else
         t_mod = t+(t_model_00-t_met_00)
        endif
!
!
!
! t_mod et t_met son reperees par rapport a la date du debut du fichier
! meteo
!
        inlc0 = 0
!
        do i = 1,dim_tempsw
         ptinf = t_met(i)
         if(i.lt.dim_tempsw) then
          ptsup = t_met(i+1)
         else
          ptsup = t_met(0)
         endif
         if((t_mod-ptinf)*(t_mod-ptsup).le.0.d0)  inlc = i
        enddo
	
        if(inlc.eq.0) then
         write(*,*)'Pb avec le fichier vague, la simu. debute avant'    &
     &  ,t_met(1),t
         stop
        else
         write(*,*)'Premier instant lu ds le fichier vague '            &
     &             ,t_met(inlc),inlc
        endif
!
	if (njour_met.ne.0) then
	 inlcp = max(1,mod(inlc+1,njour_met*4+1))
	else
	 inlcp = inlc+1
	endif
!
!
      call ionc_litr4_xyt(fic_vague_netcdf,'HS'                         &
     &,hsw1,imin,imax,jmin,jmax,inlc)
      call ionc_litr4_xyt(fic_vague_netcdf,'fp'                         &
     &,fpw1,imin,imax,jmin,jmax,inlc)
      call ionc_litr4_xyt(fic_vague_netcdf,'dir'                        &
     &,dirw1,imin,imax,jmin,jmax,inlc)
!
      call ionc_litr4_xyt(fic_vague_netcdf,'HS'                         &
     &,hsw2,imin,imax,jmin,jmax,inlcp)
      call ionc_litr4_xyt(fic_vague_netcdf,'fp'                         &
     &,fpw2,imin,imax,jmin,jmax,inlcp)
      call ionc_litr4_xyt(fic_vague_netcdf,'dir'                        &
     &,dirw2,imin,imax,jmin,jmax,inlcp)
!
! fin du if imet=1
      endif
!
!
!
      t_int = t+(t_model_00-t_met_00)
      if(njour_met.gt.0.) then
       t_mod = dmod(t,dfloat(njour_met)*86400.d0)+(t_model_00-t_met_00)
      else
       t_mod = t+(t_model_00-t_met_00)
      endif
!
      ptinf = t_met(inlc)
      if(inlc.gt.inlcp) then
       ptsup = t_met(0)
      else
       ptsup =t_met(inlcp)
      endif
!
!
!
      if((t_mod-ptinf)*(t_mod-ptsup).gt.0.d0) then
        write(*,*)'LECTURE DU FICHIER VAGUE',sngl(ptinf)/3600.,         &
     &  sngl(t_mod)/3600.,sngl(ptsup)/3600.
	
        inlc = inlc+1
        if (njour_met.ne.0) inlc = max(1,mod(inlc,njour_met*4+1))
        inlcp = inlcp+1
        if (njour_met.ne.0) inlcp = max(1,mod(inlcp,njour_met*4+1))
!
!
      call ionc_litr4_xyt(fic_vague_netcdf,'HS'                         &
     &,hsw1,imin,imax,jmin,jmax,inlc)
      call ionc_litr4_xyt(fic_vague_netcdf,'fp'                         &
     &,fpw1,imin,imax,jmin,jmax,inlc)
      call ionc_litr4_xyt(fic_vague_netcdf,'dir'                        &
     &,dirw1,imin,imax,jmin,jmax,inlc)
!
      call ionc_litr4_xyt(fic_vague_netcdf,'HS'                         &
     &,hsw2,imin,imax,jmin,jmax,inlcp)
      call ionc_litr4_xyt(fic_vague_netcdf,'fp'                         &
     &,fpw2,imin,imax,jmin,jmax,inlcp)
      call ionc_litr4_xyt(fic_vague_netcdf,'dir'                        &
     &,dirw2,imin,imax,jmin,jmax,inlcp)
!
!
      endif
!
!
!
      ptinf = t_met(inlc)
      if(inlc.gt.inlcp) then
       ptsup = t_met(0)
      else
       ptsup = t_met(inlcp)
      endif
!
      dt2 = (t_mod - ptinf)/(ptsup-ptinf)
      dt1 = -(t_mod - ptsup)/(ptsup-ptinf)
      if(dt1.lt.0.d0.or.dt2.lt.0.d0) then
       write(*,*)' Pb dt<0',dt1,dt2
       stop
!
      endif
!
!
!
      tenfonmax=0.
!
!
!
!
!
!$OMP PARALLEL
!$OMP DO PRIVATE(long,ubot,&
!$OMP&  lon,lzero,&
!$OMP&  l,tera,epsi)SCHEDULE(RUNTIME)
!
!
      do j = jmin+1,jmax
      do i = imin+1,imax
!
!
         if (h0(i,j).gt.-99.) then
! calcul de hs
!
        hs(i,j)= hsw1(i,j)*dt1+hsw2(i,j)*dt2
!
! calcul de fp
!
        fp(i,j)= fpw1(i,j)*dt1+fpw2(i,j)*dt2
!
! calcul de dir
!
        dirv(i,j)= dirw1(i,j)*dt1+dirw2(i,j)*dt2
!
!
        if(hs(i,j).ne.0.) then
!
         long=grav*(1/fp(i,j))**2/(2.*pi)
         lon=1.
         epsi=1.
!
         tera=0.
!         do while (epsi.ge.0.01)
!           tera=tera+1.
!          lon=grav*(1/fp(i,j))**2/(2.*pi)*tanh(2*pi*h0(i,j)/long)
!
!          epsi=abs(lon-long)/lon
!
!          if (tera.ge.100.) then
!             write(*,*)'trop d iteration',lon,long,fp(i,j),h0(i,j)
!     &     ,g*(1/fp(i,j))**2/(2.*pi)
!           go to 669
!
!          endif
!           long=lon 
!         enddo
!669    continue
!
         do while (epsi.ge.0.01)
           tera=tera+1.
!
          l=(lon+long)/2
!
          lzero=grav*(1/fp(i,j))**2/(2.*pi)*tanh(2*pi*h0(i,j)/l)-l
!
!
          if(lzero.ge.0.) lon=l
          if(lzero.lt.0.) long=l
          epsi=abs(lon-long)/lon  
!
!
          if (tera.ge.100.) then
             write(*,*)'trop d iteration',lon,long,fp(i,j),h0(i,j)      &
     &     ,grav*(1/fp(i,j))**2/(2.*pi)
           go to 669
          endif
!
          enddo
669    continue
         long=(lon+long)/2
!
!
! fw=0.01
!
         ubot=2.*pi*h0(i,j)/long
!
!
         if (ubot.lt.80) then
!
        ubot=amin1(pi*hs(i,j)/(1./fp(i,j)*sinh(2.*pi*h0(i,j)/long)),1.)
        excurs=1/fp(i,j)*ubot/(2*pi)
        fw=1.39*(excurs/zzeroo)**(-0.52)  
!
!
         tenfonw(i,j)=amin1(.5*fw*denseau(i,j)*ubot**2,                 &
     &   .5*fw*denseau(i,j)*6.4/4*h0(i,j))
!
!
!
        else
          tenfonw(i,j)= 0.
         endif
!
         endif
! endif test bathy
        endif
!
       enddo
      enddo
!
!
!$OMP END DO
!$OMP END PARALLEL
!
!
!
      return
#endif

      end
