 MODULE comturb

   !!======================================================================
   !!                   ***  MODULE comturb  ***
   !!
   !!======================================================================

#include "toolcpp.h"

   !! * Modules used
   USE parameters

   IMPLICIT NONE

   !! * Shared or public module variables
   REAL(kind=rsh) :: mturb,pturb,nturb,c1turb,c2turb,c3pturb,c3mturb,cmu
   REAL(kind=rsh) :: sigmaect,sigmapsi,ectmin,psimin,epsmin,fwall
   REAL(kind=rsh),DIMENSION(:,:,:),ALLOCATABLE:: eps
   REAL(kind=rsh) :: gamma
   REAL(kind=rsh) :: emin   ! turbkl_gasp
   LOGICAL        :: l_bc_turb ! if true then the BC in the psi equation will be in flux form
                               ! if false the BC is in Dirichlet form
 CONTAINS

   !!======================================================================

  SUBROUTINE alloc_comturb

   !&E---------------------------------------------------------------------
   !&E                 ***  ROUTINE alloc_comturb  ***
   !&E
   !&E---------------------------------------------------------------------
   !! * Modules used

   !!----------------------------------------------------------------------
   !! * Executable part

   IF_NOAGRIF (ALLOCATED(eps)) PRINT*,"error: comturb allocated"
   ALLOCATE(eps(kmax,limin:limax,ljmin:ljmax) )

  END SUBROUTINE alloc_comturb

   !!======================================================================

  SUBROUTINE dealloc_comturb

   !&E---------------------------------------------------------------------
   !&E                 ***  ROUTINE dealloc_comturb  ***
   !&E
   !&E---------------------------------------------------------------------
   !! * Modules used

   !!----------------------------------------------------------------------
   !! * Executable part

   DEALLOCATE(eps)

  END SUBROUTINE dealloc_comturb

 END MODULE comturb
