#if defined key_agrif
      SUBROUTINE Agrif_InitWorkspace
!
!     Modules used:
!  
      USE parameters
      USE comvarp3d
      USE comvarp2d
      USE comvars2d
      
!
!     Declarations:
!      
      IMPLICIT NONE
!
!     Variables      
!
!     Begin
!
!
      if ( .NOT. Agrif_Root() ) then
      imax=imaxm2+2
      jmax=jmaxm2+2
#if ! defined key_MPI_2D
      ljmin=jmin
      ljmax=jmax
      ljminp1=jmin+1
      ljminp2=jmin+2
      ljmaxm1=jmax-1
      ljminm2=jmin
      ljmaxp2=jmax
      ljminm1=jmin
      ljmaxp1=jmax
      ljmaxm1p1=jmax-1
      ljminp1m1=jmin+1
      ljminp1m2=jmin+2
!
! pour les i
      limin=imin
      limax=imax
      liminp1=imin+1
      liminp2=imin+2
      limaxm1=imax-1
      liminm2=imin
      limaxp2=imax
      liminm1=imin
      limaxp1=imax
      limaxm1p1=imax-1
      liminp1m1=imin+1
      liminp1m2=imin+2
#endif

      endif

!      boolsauv = .FALSE.
!      boolsort = .FALSE.
!
      if(.not. Agrif_Root()) then
       if(Agrif_Nbstepint().EQ.0) then
 !       boolsauv=Agrif_parent(boolsauv)
 !       boolsort=Agrif_parent(boolsort)
       elseif (Agrif_Nbstepint().EQ.(Agrif_Rhot()-1)) then
        dta = dt
       endif
       dt=Agrif_Parent(dt)/(Agrif_rhot())
       halfdt=dt*0.5_rlg
      endif

      agrif_SpecialValue=valmanq
      agrif_UseSpecialValue=.TRUE.
      agrif_UseSpecialValueFineGrid=.FALSE.
      agrif_SpecialValueFineGrid=valmanq
      

      Return
      End Subroutine Agrif_InitWorkspace

!
      SUBROUTINE Agrif_InitValues
!     ------------------------------------------------------------------
!     You should declare the variable which has to be interpolated here
!     -----------------------------------------------------------------
!
#include "toolcpp.h"

!     Modules used:
!  
      USE comvarp2d
      USE comvarp3d
      USE comvars2d
      USE comvars3d
      USE comcolig2d,   ONLY : igdv_old
      USE comfluxdo
      USE comturb,      ONLY : eps
      USE agrifcommonid
      USE comdiag,      ONLY : l_diag
      USE output, ONLY : output_init,output_mng,l_out_demer,nb_out
#ifdef key_substance
      USE subreaddat,   ONLY : sub_read_var,sub_read_vardiag,sub_sflx_read
      USE comsubstance, ONLY : nv_dri,cv_wat,l_cvrain_readfile,l_subflxatm_readfile,l_bilan
   USE usersubstance,   ONLY : user_init_vdriv
   USE submassbalance,  ONLY : sub_budget_readdomain
#ifdef key_biolo
      USE bioloinit,  ONLY : biolo_userinit
#endif
#endif
      USE sflxatm, ONLY : drag,exch,imeteo_dragtype
      USE sflxturb, ONLY : sflx_coef_init
      USE trackpoints, ONLY : l_points,track_points
#ifdef key_trajec3d
   USE traject3d, ONLY : traj_init3d
#endif
#ifdef key_trajec2d
   USE traject2d, ONLY : traj_init2d
#endif
#ifdef key_MPI_2D
   USE toolmpi, ONLY: MPI_START1,MPI_START2,MPI_START3,MPI_END1
   USE toolmpi, ONLY: ADD_TAG,ex_j_rsh
#endif
!
!
!     Declarations:
!      
      Implicit none
!
!     Variables      
!
     INTEGER :: i,j,nb,narg
!
!
!     Begin
!
!     Specific fine grid Initializations
!
!      
!     We should declare the type of variable which have to be interpolated
!
integer :: k,l
   REAL(kind=rsh), dimension(:,:),allocatable   :: xtemp,utemp
   REAL(kind=rsh), dimension(:,:,:),allocatable :: uztemp,tstemp
   External :: interphx,interphy,interph0
   External :: interpu_stepu,interpv_stepu,interpssh,interpxeu,interpxev,interpuz_stepu
   External :: interpvz_stepu,interp3dtemp,interp3dsal
!
!
#ifdef key_substance 
     External :: interp3dsub
   REAL(kind=rsh), dimension(:,:,:,:),allocatable :: tsstemp
#endif
!

!
           
!
      nbouc=0
!
! Variables initialization
!
      nracin='zzzz'
      root='./'
!
! Call routines for initializations
!
#ifdef key_MPI_2D
   CALL MPI_START1
#endif


      narg=0
      call init(narg)
      tsauv=Agrif_parent(tsauv)
      l_obc2drank_save=.false.  

   ! Read parameters of XXXXX
#ifdef key_waveforcing
     CALL lec_para_swan
#endif

   ! Initialize flux exchange coefficients
      IF (imeteo_exchtype==1) call sflx_coef_init(drag,exch,imeteo_dragtype)
   ! Read the bathymetry
      call bathy
   ! Initialize ig,id,jb,jh
      call grid_mask

   ! Divide the domain for MPI run
#ifdef key_MPI_2D
     CALL MPI_START2(1,1)
     CALL MPI_START3
#endif

   ! Allocation of variables
   ! -----------------------
      ! Dynamical variables
      call ALLOC
      ! Intermediate variables
      CALL alloc_inter
      ! Stationnary variable (grid metrics)
      CALL alloc_stat

   ! Initialize metrics (dx,dy,sig,lon,lat...)
      call grid_metric

#ifdef key_substance
   ! Read file variables.dat describing substances
   ! Allocate substance variables
   ! Make variables in order
     CALL sub_read_var

#ifdef key_sedim
!toseelater utile cela ou dramatique ? (cval)
     CALL sed_alloc
     IF (l_repsed) THEN
       CALL sed_init_fromfile
     ELSE
       CALL sed_init
     END IF
     CALL sed_settlveloc_ini
     IF(l_morphocoupl)CALL sed_morphoinit
#endif

#ifdef key_biolo
   ! Read file vardiag.dat describing diagnoses
   ! Allocate diagnoses variables
     CALL sub_read_vardiag
#endif
#ifdef key_eco3m
! Initialization of ECO3M
   IF (nbouc == 0) THEN
     nbcallbio = -1
     CALL main_bio
     CALL alloc_var_eco3m
     !In order to compute the modulo of the call to ECO3M
     dt_phy_ini= dt
   END IF
#endif
#endif

   ! ID and spatial extension of the pronostic variables (ssh,sal,temp,u,uz,v,vz,cv_wat) and h0, hx, hy
       Call Agrif_Declare_Variables

   ! INITIALIZATION OF STATE VARIABLES XE,U,V,UZ,VZ,SAL,TEMP,CV_WAT
   ! --------------------------------------------------------------

       Call Agrif_Update_Variable(hx,hx_id,procname=interphx)
       Call Agrif_Update_Variable(hy,hy_id,procname=interphy)
       Call Agrif_Update_Variable(h0,h0_id,procname=interph0)
!
!******** on remplit les coordonnees + resolution ds un tab
!
!      indice = Agrif_Fixed()
!      data_grid(indice,1) = fisac
!      data_grid(indice,2) = finac
!      data_grid(indice,3) = dfiac
!      data_grid(indice,4) = gwac
!      data_grid(indice,5) = geac
!      data_grid(indice,6) = dgac
!      data_grid(indice,7) = dyac
!
!******** obligatoire ***********
!
      dt=Agrif_Parent(dt)/(Agrif_rhot())
      t=Agrif_Parent(t)
      tdebagrif_messat=Agrif_Parent(tdebagrif_messat)
!
!********************************
!
      allocate(xtemp(liminm2:limaxp2,ljminm2:ljmaxp2))
      allocate(utemp(liminm2:limaxp2,ljminm2:ljmaxp2))
      allocate(uztemp(kmax,liminm2:limaxp2,ljminm2:ljmaxp2))
      allocate(tstemp(kmax,liminm1:limaxp2,ljminm1:ljmaxp2))
#ifdef key_substance
      allocate(tsstemp(nb_var,kmax,liminm1:limaxp2,ljminm1:ljmaxp2))
#endif
!
! a revoir avec les nouvelles routines init
!******************************************
!
! les niveaux : au passage xeuv n est initialise qu au bord
! on commence par creer un masque terre pour les xe
!
! if .True. we use only mother grid s values unequal to Agrif_SpecialValue
! to do the spatial interpolation
! 
      Agrif_SpecialValue=valmanq
      Agrif_UseSpecialValue=.TRUE.

! if .True. we fill daughter s cells if they differ from
! Agrif_SpecialValueFineGrid
!
      Agrif_SpecialValueFineGrid=valmanq
      Agrif_UseSpecialValueFineGrid=.false.

! Initialization to make sure the initial value is different from valmanq
!
      ssh(:,:) = 0.0_rsh
      where(h0(liminm2:limaxp2,ljminm2:ljmaxp2)==-valmanq) ssh(liminm2:limaxp2,ljminm2:ljmaxp2)=valmanq

! spatial interpolation
!
     Call Agrif_Init_Variable(xtemp,ssh_id,procname=interpssh)
     ssh(liminm2:limaxp2,ljminm2:ljmaxp2)=xtemp(liminm2:limaxp2,ljminm2:ljmaxp2)
     where(h0(liminm2:limaxp2,ljminm2:ljmaxp2)==-valmanq) ssh(liminm2:limaxp2,ljminm2:ljmaxp2)=valmanq

     xeadv(limin:limax,ljmin:ljmax)=ssh(limin:limax,ljmin:ljmax)

     CALL init_height(ssh)
!
! les vitesses barotropes
!
! if .FALSE. we use all mother grid s values to interpolate
! on all daughter grid s cells
!
      Agrif_UseSpecialValue=.FALSE.      
      Agrif_UseSpecialValueFineGrid=.FALSE.

! spatial interpolation
!
      Call Agrif_Init_Variable(utemp,u_id,procname=interpu_stepu)
      u(liminm2:limaxp2,ljminm2:ljmaxp2)=utemp(:,:)
      Call Agrif_Init_Variable(utemp,v_id,procname=interpv_stepu)
      v(liminm2:limaxp2,ljminm2:ljmaxp2)=utemp(:,:)
      where(hx(liminm2:limaxp2,ljminm2:ljmaxp2)==-valmanq-h0fond) u(liminm2:limaxp2,ljminm2:ljmaxp2)=0.0_rsh
      where(hy(liminm2:limaxp2,ljminm2:ljmaxp2)==-valmanq-h0fond) v(liminm2:limaxp2,ljminm2:ljmaxp2)=0.0_rsh
!
! les vitesses completes
!
      Call Agrif_Init_Variable(uztemp,uz_id,procname=interpuz_stepu)
      uz(1:kmax,liminm2:limaxp2,ljminm2:ljmaxp2)=uztemp(:,:,:)
      Call Agrif_Init_Variable(uztemp,vz_id,procname=interpvz_stepu)
      vz(1:kmax,liminm2:limaxp2,ljminm2:ljmaxp2)=uztemp(:,:,:)
!
      do k=1,kmax
        where(hx(liminm2:limaxp2,ljminm2:ljmaxp2)==-valmanq-h0fond) uz(k,liminm2:limaxp2,ljminm2:ljmaxp2)=0.0_rsh
        where(hy(liminm2:limaxp2,ljminm2:ljmaxp2)==-valmanq-h0fond) vz(k,liminm2:limaxp2,ljminm2:ljmaxp2)=0.0_rsh
      end do
      wz(:,:,:)=0.0_rsh
!
! temperature et salinite . l appel a  init_tssub sert a mettre
! les valeurs a terre a valmanq les autres valeurs sont
! interpolees dans les routines suivantes
!
      Agrif_SpecialValue=valmanq
      Agrif_UseSpecialValue=.TRUE.

! Initialization to make sure the initial value is different from valmanq
!
      sal = 0.0_rsh
      temp = 0.0_rsh
#ifdef key_substance
      cv_wat = 0.0_rsh
#endif

      Call Agrif_Init_Variable(tstemp,sal_id,procname=interp3dsal)
      sal(1:kmax,liminm1:limaxp2,ljminm1:ljmaxp2)=tstemp(:,:,:)
      Call Agrif_Init_Variable(tstemp,temp_id,procname=interp3dtemp)
      temp(1:kmax,liminm1:limaxp2,ljminm1:ljmaxp2)=tstemp(:,:,:)
      do k=1,kmax
    !   where(h0(:,:)==-valmanq) sal(k,:,:)=valmanq
    !   where(h0(:,:)==-valmanq) temp(k,:,:)=valmanq
       where(h0(liminm1:limaxp2,ljminm1:ljmaxp2)==-valmanq) sal(k,liminm1:limaxp2,ljminm1:ljmaxp2)=valmanq
       where(h0(liminm1:limaxp2,ljminm1:ljmaxp2)==-valmanq) temp(k,liminm1:limaxp2,ljminm1:ljmaxp2)=valmanq
      end do
!
! les autres traceurs
!
#ifdef key_substance
      Call Agrif_Init_Variable(tsstemp,cv_wat_id,procname=interp3dsub)
      cv_wat(1:nb_var,1:kmax,liminm1:limaxp2,ljminm1:ljmaxp2)=tsstemp(:,:,:,:)

      do l=1,nb_var
       do k=1,kmax
!        where(h0(:,:)==-valmanq) cv_wat(l,k,:,:)=valmanq
         where(h0(liminm1:limaxp2,ljminm1:ljmaxp2)==-valmanq) cv_wat(l,k,liminm1:limaxp2,ljminm1:ljmaxp2)=valmanq
       end do
      end do
#endif
!
      Agrif_UseSpecialValue=.FALSE.   
      Agrif_UseSpecialValueFineGrid=.FALSE.
!
! comme on ne sait pas par quoi on commence (stepu ou v)
! fait pour initilaiser les old values
!-------------------------------------------------------
!
   ! Initialize viscosity coefficients
      call init_viscoef
   ! Initialize coefficients of turbulence
      call init_turbcoef(ect,psi)

   ! Restart from a file ( restart file from MARS or climatological file )
     IF (l_initfromfile) THEN
       CALL init_fromfile(u,uz,v,vz,ssh,sal,temp,        &
                                        vstar,igdv_old,  &
#ifdef key_substance
                                            cv_wat,      &
#endif
                                            ect,psi,eps)
     END IF

   ! Initialize wave fields
#ifdef key_waveforcing
     CALL init_wave_forcing_fric
     CALL lect_wave
!cval ?     CALL bathy
     CALL compute_wave_forcing
#endif

   ! Initialize ecosystem variables
#ifdef key_substance
#ifdef key_biolo
   ! User special initialization of cv_wat.
     CALL biolo_userinit(cv_wat)
#endif
!!!! CAR INITIALISE DANS STEP POUR SEDIM REVOIR ?#if defined key_sedim_anc ||
!defined key_contaminant
#if defined key_contaminant
!!!!! deja fait avec sedim??     IF (.NOT.l_initfromfile) CALL
!sed_settlveloc_ini
     CALL conta_read_react
!!!!!     CALL conta_userinit
#endif
#endif

#ifdef key_substance
   ! initialization of driving variables
     IF (nv_dri > 0) &
       CALL user_init_vdriv(cv_wat                       &
#ifdef key_sedim
                           ,cv_sed                       &
#endif
                                )
#endif

   ! Read output.dat and allocate variables with the correct number of output files
     CALL output_init

#ifdef key_substance
   !!! introduction of submassbalance
     IF (l_bilan) CALL sub_budget_readdomain(ssh)
     PRINT_DBG*, 'call read_limits'
   !!! end submassbalance
#endif

   CALL_MPI ex_j_rsh(-2,2,1,liminm2,limaxp2,ljminm2,ljmaxp2,v(liminm2:limaxp2,ljminm2:ljmaxp2)) ! for dyn2d_dt val
   CALL_MPI ex_i_rsh(-2,2,1,liminm2,limaxp2,ljminm2,ljmaxp2,u(liminm2:limaxp2,ljminm2:ljmaxp2)) ! for dyn2d_dt val

   ! Save summary of simulation
   CALL summary

   ! Initialize meteorological variables if l_meteo_stat or l_meteo_hom
      call meteo
   ! Read file river.dat, initialize river discharges inputs with time interpolation
      call river(ssh)

#ifdef key_substance
   ! Read file outflow.dat, file describing discharges
   ! initialize discharges inputs with time interpolation
      call outflow

   ! Read files sflx_cvrain and/or sflx_subflxatm
   ! if temporal variations of cvrain or of atm. fluxes for at least one
   ! substance
   !  (l_cvrain_readfile=.true. or l_subflxatm_readfile=.true.)
   IF (l_cvrain_readfile .or. l_subflxatm_readfile) CALL sub_sflx_read
#endif

   ! Estimate buoyancy from sal and temp
   IF (l_modele2d) THEN
     IF (icon == 2) CALL ts_stateeq2d(sal)
   ELSE
     IF (icon >= 1 .AND. l_stateeq_lin) CALL ts_stateeq_linear (sal,temp,boz)
     IF (icon >= 1 .AND. .NOT.l_stateeq_lin) CALL ts_stateeq_blumberg(sal,temp,boz)
   END IF

! Must be called on because initialization for nbouc=0
! Moved because variables may be saved at initial step

     CALL output_mng

   ! Initialize demerliac filter
   DO nb=1,nb_out
!cval bizarre : meme variables
      if (l_out_demer(nb)) CALL out_demerliac(ssh(limin:limax,ljmin:ljmax), &
                           u(limin:limax,ljmin:ljmax),uz(:,limin:limax,ljmin:ljmax), &
                           v(limin:limax,ljmin:ljmax),vz(:,limin:limax,ljmin:ljmax), &
                           sal(:,limin:limax,ljmin:ljmax),temp(:,limin:limax,ljmin:ljmax), &
                           ssh(limin:limax,ljmin:ljmax), &
                           u(limin:limax,ljmin:ljmax),uz(:,limin:limax,ljmin:ljmax), &
                           v(limin:limax,ljmin:ljmax),vz(:,limin:limax,ljmin:ljmax), &
                           sal(:,limin:limax,ljmin:ljmax),temp(:,limin:limax,ljmin:ljmax), &
#ifdef key_substance
                           cv_wat(:,:,limin:limax,ljmin:ljmax), cv_wat(:,:,limin:limax,ljmin:ljmax),    &
#endif
                           0)
   END DO

      if(l_points) call track_points(u,v,uz,vz,ssh,sal,temp,          &
#ifdef key_substance
                                                     cv_wat,        &
#endif
                                                     ect,boz)

      if(l_diag) call diagnostic(u,v,uz,vz,ssh,sal,temp,            &
#ifdef key_substance
                                                   cv_wat,          &
#endif
                                                   ect,boz)
!
#ifdef key_trajec3d
   IF (nbouc == 0.and..not.l_modele2d) CALL traj_init3d(ssh)
#endif
#ifdef key_trajec2d
   IF (nbouc == 0.and.l_modele2d) CALL traj_init2d
#endif
!
      Return
      End Subroutine Agrif_InitValues
!

      SUBROUTINE Agrif_detect(g,size)
!
!     Modules used:
!  
      USE Agrif_Util
!
!
!     Declarations:
!      
      IMPLICIT NONE      
!
!     Variables      
!
      Type(Agrif_Grid),pointer   :: g        ! Pointer on the current grid
      INTEGER, DIMENSION(3)      :: size
!
!     Begin
!
!

!
      Return
      End Subroutine Agrif_detect

#ifdef key_MPI_2D
        Subroutine Agrif_Invloc(indloc,proc,dir,indglob)
        implicit none
        integer indloc, proc, dir, indglob
!# include "param.h"        
        If (dir == 1) Then
!           indglob = indloc + iminmpi-1     
         indglob = indloc     
        Else If (dir == 2) Then
!           indglob = indloc + jminmpi-1
          indglob = indloc
        Else 
           indglob = indloc
        End If
        Return
        End
#endif

!
#else
      subroutine Subcalledbyagrif
         write(*,*) 'Impossible to bet here'
      end subroutine Subcalledbyagrif
#endif
