!********************************************************************
!     
  SUBROUTINE agrif_declare_variables

   !&E---------------------------------------------------------------------
   !&E                 ***  ROUTINE  agrif_declare_variable  ***
   !&E
   !&E ** Purpose : 
   !&E
   !&E ** Description : 
   !&E
   !&E ** Called by : 
   !&E
   !&E ** External calls :
   !&E
   !&E ** Reference :
   !&E
   !&E ** History :
   !&E                   Original code
   !&E             2010-06  (F. Dumas ) 
   !&E       !  2011-11  (V. Garnier) Spatial extension of ssh(liminm2:limaxp2,ljminm2:ljmaxp2)
   !&E
   !&E---------------------------------------------------------------------
   !! * Modules used
#ifdef key_agrif
   USE parameters
   USE agrifcommonid

   !! * Arguments

   !! * local declarations

   !!----------------------------------------------------------------------
   !! * Executable part
!
   CALL Agrif_Declare_Variable((/2,2/),(/2,2/),(/'x','y'/),(/liminm2,ljminm2/),(/limaxp2,ljmaxp2/),ssh_id)
   CALL Agrif_Set_bc(ssh_id,(/0,1/))
   CALL Agrif_Set_bcinterp(ssh_id,interp=Agrif_linear)
   CALL Agrif_Set_interp(ssh_id,interp=Agrif_linear)
   CALL Agrif_Set_UpdateType(ssh_id,update=Agrif_Update_Average)
!
   CALL Agrif_Declare_Variable((/2,2/),(/2,2/),(/'x','y'/),(/liminm2,ljminm2/),(/limaxp2,ljmaxp2/),h0_id)
   CALL Agrif_Set_UpdateType(h0_id,update=Agrif_Update_Average)
!
   CALL Agrif_Declare_Variable((/1,2/),(/1,2/),(/'x','y'/),(/liminm2,ljminm2/),(/limaxp2,ljmaxp2/),hx_id)
   CALL Agrif_Set_UpdateType(hx_id,update1=agrif_update_copy,update2=agrif_update_average)
!
   CALL Agrif_Declare_Variable((/2,1/),(/2,1/),(/'x','y'/),(/liminm2,ljminm2/),(/limaxp2,ljmaxp2/),hy_id)
   CALL Agrif_Set_UpdateType(hy_id,update2=agrif_update_copy,update1=agrif_update_average)
!
   CALL Agrif_Declare_Variable((/1,2/),(/1,2/),(/'x','y'/),(/liminm2,ljminm2/),(/limaxp2,ljmaxp2/),u_id)
   CALL Agrif_Set_bc(u_id,(/0,1/))
   CALL Agrif_Set_bcinterp(u_id,interp=Agrif_linear)
   CALL Agrif_Set_interp(u_id,interp=Agrif_linear)
   CALL Agrif_Set_UpdateType(u_id,update1=agrif_update_copy,update2=agrif_update_average)
!
   CALL Agrif_Declare_Variable((/0,1,2/),(/1,2,0/),(/'N','x','y'/),(/1,liminm2,ljminm2/),(/kmax,limaxp2,ljmaxp2/),uz_id)
   CALL Agrif_Set_bc(uz_id,(/0,1/))
   CALL Agrif_Set_interp(uz_id,interp=Agrif_linear)
   CALL Agrif_Set_bcinterp(uz_id,interp=Agrif_linear)
  !CALL Agrif_Set_UpdateType(uz_id,update=Agrif_Update_Full_Weighting)
   CALL Agrif_Set_UpdateType(uz_id,update1=agrif_update_copy,update2=agrif_update_average)
!
   CALL Agrif_Declare_Variable((/2,1/),(/2,1/),(/'x','y'/),(/liminm2,ljminm2/),(/limaxp2,ljmaxp2/),v_id)
   CALL Agrif_Set_bc(v_id,(/0,1/))
   CALL Agrif_Set_bcinterp(v_id,interp=Agrif_linear)
   CALL Agrif_Set_interp(v_id,interp=Agrif_linear)
   CALL Agrif_Set_UpdateType(v_id,update2=agrif_update_copy,update1=agrif_update_average)
!
   CALL Agrif_Declare_Variable((/0,2,1/),(/2,1,0/),(/'N','x','y'/),(/1,liminm2,ljminm2/),(/kmax,limaxp2,ljmaxp2/),vz_id)
   CALL Agrif_Set_bc(vz_id,(/0,1/))
   CALL Agrif_Set_interp(vz_id,interp=Agrif_linear)
   CALL Agrif_Set_bcinterp(vz_id,interp=Agrif_linear)
  !CALL Agrif_Set_UpdateType(vz_id,update=Agrif_Update_Full_Weighting)
   CALL Agrif_Set_UpdateType(vz_id,update2=agrif_update_copy,update1=agrif_update_average)
!
   CALL Agrif_Declare_Variable((/0,2,2/),(/2,2,0/),(/'N','x','y'/),(/1,liminm1,ljminm1/),(/kmax,limaxp2,ljmaxp2/),temp_id)
   CALL Agrif_Set_bc(temp_id,(/0,1/))
   CALL Agrif_Set_bcinterp(temp_id,interp=Agrif_linear)
   CALL Agrif_Set_interp(temp_id,interp=Agrif_linear)
  !CALL Agrif_Set_UpdateType(temp_id,update=Agrif_Update_Full_Weighting)
   CALL Agrif_Set_UpdateType(temp_id,update=Agrif_Update_Average)
!
   CALL Agrif_Declare_Variable((/0,2,2/),(/2,2,0/),(/'N','x','y'/),(/1,liminm1,ljminm1/),(/kmax,limaxp2,ljmaxp2/),sal_id)
   CALL Agrif_Set_bc(sal_id,(/0,1/))
   CALL Agrif_Set_bcinterp(sal_id,interp=Agrif_linear)
   CALL Agrif_Set_interp(sal_id,interp=Agrif_linear)
  !CALL Agrif_Set_UpdateType(sal_id,update=Agrif_Update_Full_Weighting)
   CALL Agrif_Set_UpdateType(sal_id,update=Agrif_Update_Average)
!
#ifdef key_substance
   CALL Agrif_Declare_Variable((/0,0,2,2/),(/2,2,0,0/),(/'N','N','x','y'/),(/1,1,liminm1,ljminm1/),(/nb_var,kmax,limaxp2,ljmaxp2/),cv_wat_id)
   CALL Agrif_Set_interp(cv_wat_id,interp=Agrif_Linear)
   CALL Agrif_Set_bcinterp(cv_wat_id,interp=Agrif_Linear)
   CALL Agrif_Set_bc(cv_wat_id,(/0,1/))
  !CALL Agrif_Set_UpdateType(cv_wat_id,update=Agrif_Update_Full_Weighting)
   CALL Agrif_Set_UpdateType(cv_wat_id,update=Agrif_Update_Average)
#endif

#endif
  END SUBROUTINE agrif_declare_variables

