   !&E   ***************   include dyn3dx_cont.h   **********************************
   !&E
   !&E ** Purpose : remplissage des termes du systeme lineaire
   !&E              provenant de la discretisation de l equation de
   !&E              continuite dans le systeme d equation de Saint-
   !&E              Venant sur l ensemble de la grille de calcul.
   !&E
   !&E ** Description : Equation couplee a celle de la conservation de la
   !&E                  quantite de mouvement dans la direction Ouest-Est.
   !&E
   !&E
   !&E ** Called by : dyn2dx
   !&E
   !&E ** External calls :
   !&E
   !&E ** Reference :
   !&E                T. Duhaut, M. Honnorat, L. Debreu, 2008 : Rapport
   !&E                contrat PREVIMER - Ref : 06/2 210 290 (pages 100-125)
   !&E
   !&E ** History : 2006-05
   !&E              2007-09 (V. Garnier) homogeneneity of dx dy...
   !&E       !  2008-07  (L. Debreu, M. Honnorat, T. Duhaut) time scheme
   !&E       !  2008-08  (T. Duhaut) time scheme Rq : schema des traceurs 
   !&E                               semble instable si u est decomposee en
   !&E                               alpha u et (alpha - 1) u
   !&E
   !&E-------------------------------------------------------------------------

   ! 1- terme de diagonale de la matrice tridiagonale
   !    du modele barotrope
   !--------------------------------------------------

   ! 2- terme de sous-diagonale de la matrice tridiagonale
   !    issu de l implicitation de la divergence de flux zonale
   !    (flux a l ouest du point xe(i,j) considere). Remplissage
   !    du tableau hex qui ressert dans les flux de traceurs
   !------------------------------------------------------------

      axe(i,j)=-halfdt*dy_u(i-1,j)/surf(i,j)*hex(i-1,j)
      bxe(i,j)=fwet(i,j)

   ! 3- terme de sous-diagonale de la matrice tridiagonale
   !    issu de l implicitation de la divergence de flux zonale
   !    (flux a l est du point xe(i,j) considere). Remplissage
   !    du tableau hex qui ressert dans les flux de traceurs
   !-----------------------------------------------------------

       cxe(i,j)=halfdt*dy_u(i,j)/surf(i,j)*hex(i,j)

   ! 4- terme du vecteur second membre du systeme lineaire
   !    issu de la divergence de flux meridienne
   !    (flux au nord et sud  du point xe(i,j) considere)
   !    Prise en compte de tous les apports d eau dans
   !    la colonne d eau. Remplissage
   !    du tableau hey qui ressert dans les flux de traceurs
   !----------------------------------------------------------
!FVDM 5/02/2014
! Relaxation de la surface libre : si actif ne restart pas
       y2dxe(i,j)=xec(i,j)*fwetp(i,j)-halfdt/surf(i,j)*(                       &
                           ( hey(i,j  )*vstar(i,j  )*dx_v(i,j  )    &
                           - hey(i,j-1)*vstar(i,j-1)*dx_v(i,j-1) )  &
                           - SUM(phieau(:,i,j)) )   !                &
!FVDM : pas utilisable si maree avec l_tide_harmcompo=.true.
!			   -halfdt*tau_out*forwrka(i,j)*(xec(i,j)-obc_xeall(i,j))

   !&E   ***************   end include dyn3dx_cont.h   ******************************
