!**************include dyn3dx_genpot  ***********************************

   !&E---------------------------------------------------------------------
   !&E                 ***  dyn3dx_genpot.h  ***
   !&E
   !&E ** Purpose : estimate the trend term relative to the tidal potential
   !&E              for the zonal momentum forcing (2D and 3D equation)
   !&E
   !&E ** Description : explicit
   !&E
   !&E ** Called by : included into dyn3dxtlscoef.F90
   !&E
   !&E ** External calls :
   !&E
   !&E ** Used ij-arrays : potgene,dx_u
   !&E
   !&E ** Modified variables : yz_exp,intz_exp
   !&E
   !&E ** Reference :
   !&E
   !&E ** History :
   !&E       !  1987-02  (P. Lazure)  Original code
   !&E       !  2007-09 (V. Garnier) homogeneneity of dx dy...
   !&E
   !&E---------------------------------------------------------------------


     yz_exp(:,i,j)=yz_exp(:,i,j)+(potgene(i+1,j)-potgene(i,j))/ &
                                 (dx_u(i,j)*rhoref)
     intz_exp(i,j)=intz_exp(i,j)+(potgene(i+1,j)-potgene(i,j))/ &
                                 (dx_u(i,j)*rhoref)

!************** end include dyn3dx_genpot  ***********************************
