!************    including dyn3dx_wave.h       ****************

   !&E---------------------------------------------------------------------
   !&E                 ***  dyn3dx_wave.h  ***
   !&E
   !&E ** Purpose : estimate the trend term relative to the waves forcing :
   !&E              radiation stress tensor (3D equation)
   !&E
   !&E ** Description : explicit
   !&E
   !&E ** Called by : included into dyn3dxtlscoef.F90
   !&E
   !&E ** External calls :
   !&E
   !&E ** Used ij-arrays : yz_exp,tosx3dm
   !&E
   !&E ** Modified variables : yz_exp
   !&E
   !&E ** Reference :
   !&E
   !&E ** History :
   !&E       !  2010-03  (A.-C. Bennis)  Original code
   !&E
   !&E---------------------------------------------------------------------

   DO k=1,kmax
     yz_exp(k,i,j)= yz_exp(k,i,j)+tosx3dm(i,j,k)
   END DO

!*************    end including dyn3dx_wave.h     ************
