!**************      include dyn3dy_genpot.h    ************************

   !&E---------------------------------------------------------------------
   !&E                 ***  dyn3dy_genpot.h  ***
   !&E
   !&E ** Purpose : estimate the trend term relative to the tidal potential
   !&E              for the meridional momentum forcing (2D and 3D equation)
   !&E
   !&E ** Description : explicit
   !&E
   !&E ** Called by : included into dyn3dytlscoef.F90
   !&E
   !&E ** External calls :
   !&E
   !&E ** Used ij-arrays : potgene,dy_v
   !&E
   !&E ** Modified variables : yz_exp,intz_exp
   !&E
   !&E ** Reference :
   !&E
   !&E ** History :
   !&E       !  1987-02  (P. Lazure)  Original code
   !&E       !  2007-09 (V. Garnier) homogeneneity of dx dy...
   !&E
   !&E---------------------------------------------------------------------

     yz_exp(:,i,j)=yz_exp(:,i,j)+(potgene(i,j+1)-potgene(i,j))/ &
                                 (dy_v(i,j)*rhoref)
     intz_exp(i,j)=intz_exp(i,j)+(potgene(i,j+1)-potgene(i,j))/ &
                                 (dy_v(i,j)*rhoref)

!************** end include dyn3dy_genpot  **********************
