  SUBROUTINE read_climato_field

   !&E---------------------------------------------------------------------
   !&E                 ***  ROUTINE read_climato_field  ***
   !&E
   !&E ** Purpose : read  monthly climatological field
   !&E              
   !&E
   !&E ** Description :
   !&E
   !&E ** Called by : main
   !&E
   !&E ** External calls : 
   !&E
   !&E ** 
   !&E
   !&E ** Modified variables : 
   !&E
   !&E ** Reference :
   !&E
   !&E ** History :
   !&E       ! 2011-02-23 (S. Theetten) 
   !&E
   !&E---------------------------------------------------------------------

   !! * Modules used
   USE parameters
   USE comvars2d
   USE netcdf

   IMPLICIT NONE

   INTEGER :: status, ncid, turb_id
   character(len=200) :: climato_file
   print*, "read monthly climatological turbidity field"
   
   climato_file = '../../inputs/Turbidity_climato_2003_2010_MANGA_2500.nc'
   status=nf90_open(trim(climato_file),mode=nf90_share,ncid=ncid)
   if (status /= nf90_noerr) then
      print*,'unable to open nc file: ',trim(climato_file)
      stop
   END if

   status=nf90_inq_varid(ncid,'turbidity',turb_id)
   if (status /= nf90_noerr) then
      print*,'unable to retrieve turbidity id'
   end if
   
   status=nf90_get_var(ncid,turb_id,turb_field)
   if (status /= nf90_noerr) then
      print*,'unable to get turbidity var'
   end if



 END SUBROUTINE READ_CLIMATO_FIELD

