  FUNCTION tool_latlon2i(longitude,latitude)
 
   !&E---------------------------------------------------------------------
   !&E                 ***  FUNCTION tool_latlon2i  ***
   !&E
   !&E ** Purpose : convert the geographic coordinates into an i grid index
   !&E
   !&E ** Description :
   !&E
   !&E ** Called by : paramet,init
   !&E
   !&E ** External calls : 
   !&E
   !&E ** Used ij-arrays : 
   !&E
   !&E ** Modified variables : tool_latlon2i
   !&E
   !&E ** Reference :
   !&E
   !&E ** History :
   !&E       !  2004-10-28
   !&E
   !&E---------------------------------------------------------------------
   !! * Modules used
   USE parameters
   USE comvars2d
   IMPLICIT NONE

   !! * Function declaration
   REAL(kind=rsh)             :: tool_latlon2i

   !! * Arguments
   REAL(kind=rlg),INTENT(in)  :: longitude,latitude

   !!----------------------------------------------------------------------
   !! * Executable part

   ! aie et comment fait on pour grilles non regulieres ????
   tool_latlon2i=(REAL(longitude,riolg)-gwac)/dgac+1.0_riolg

  END FUNCTION tool_latlon2i
