 MODULE toolmath
   !!======================================================================
   !!                   ***  MODULE toolmath  ***
   !! Mathematical functions
   !!======================================================================
   !! * Modules used

   IMPLICIT NONE
   PRIVATE

   !! * Accessibility
   PUBLIC sumindex                    ! function called by

   !! * Shared or public module variables

   !! * Private variables

 CONTAINS
   !!======================================================================
 
  FUNCTION sumindex(nstart,nend)
 
   !&E---------------------------------------------------------------------
   !&E                 ***  FUNCTION sumindex  ***
   !&E
   !&E ** Purpose : sum of indexes associated to biological variables
   !&E              to make sure all indexes are initialized
   !&E
   !&E ** Description :
   !&E
   !&E ** Called by :
   !&E
   !&E ** External calls : 
   !&E
   !&E ** Used ij-arrays : 
   !&E
   !&E ** Modified variables :
   !&E
   !&E ** Reference :
   !&E
   !&E ** History :
   !&E       !  2009-10  (V. Garnier)  Original code
   !&E
   !&E---------------------------------------------------------------------
   !! * Modules used

   !! * Arguments
   INTEGER, INTENT( in ) :: nstart,nend          ! index of the begining/end of the series
   INTEGER               :: sumindex             ! result of the function

   !! * Local declarations
   INTEGER               :: i                    ! loop index

   !!----------------------------------------------------------------------
   !! * Executable part

   sumindex = nstart
   i = nstart + 1

   DO WHILE (i <= nend)
     sumindex = sumindex + i
     i = i + 1
   END DO

  END FUNCTION sumindex

 END MODULE
