!  SUBROUTINE tssub_eq(xe2,xe3,sal,temp        &
!#ifdef key_substance
!                                      ,cv_wat &
!#endif
!                                             )

   !&E---------------------------------------------------------------------
   !&E                 ***  ROUTINE tssub_eq  ***
   !&E
   !&E ** Purpose : framework for the subroutine of tracers transport computation
   !&E
   !&E ** Description : see tssub_eq_wquick.h or tssub_eq_wcen.h
   !&E                  for different possibilities of subroutine body
   !&E
   !&E ** Called by : stepu, stepv
   !&E
   !&E ** External calls : tssub_eq_hm
   !&E
   !&E ** Used ij-arrays : xe2, xe3, u, v
   !&E
   !&E ** Modified variables : sal, temp, cv_wat
   !&E
   !&E ** Reference :
   !&E
   !&E ** History :
   !&E       !  2004-10-06
   !&E
   !&E---------------------------------------------------------------------
   !! * Modules used

   !! * Arguments

   !! * Local declarations

   !!----------------------------------------------------------------------
   !! * Executable part

#if defined key_tssub_wquickupwind
#if defined key_siggen || defined key_gencoord
#include "tssub_eq_wquick_sig.h"
#else
#include "tssub_eq_wquick.h"
#endif

#elif defined key_tssub_wcompact
#if defined key_siggen || defined key_gencoord
#include "tssub_eq_wcompact_sig.h"
#else
#include "tssub_eq_wcompact.h"
#endif

#else
#if defined key_siggen || defined key_gencoord
#include "tssub_eq_wcen_sig.h"
#else
#include "tssub_eq_wcen.h"
#endif

#endif


!  END SUBROUTINE tssub_eq
